%global __brp_check_rpaths %{nil}

%define basen     freecell-solver
%define major     0
%define libname   %mklibname %{basen} %{major}
%define develname %mklibname %{basen} -d

Name: %{basen}
Version: 6.8.0
Release: %mkrel 3
Summary: The Freecell Solver Executable
License: MIT
Group: Games/Cards
URL: https://fc-solve.shlomifish.org/
Source0: https://fc-solve.shlomifish.org/downloads/fc-solve/%{name}-%{version}.tar.xz

BuildRequires: cmake
BuildRequires: gmp-devel
BuildRequires: gperf
BuildRequires: perl(CHI)
BuildRequires: perl(Carp)
BuildRequires: perl(Cwd)
BuildRequires: perl(Data::Dumper)
BuildRequires: perl(Digest::SHA)
BuildRequires: perl(Env::Path)
BuildRequires: perl(File::Path)
BuildRequires: perl(File::Spec)
BuildRequires: perl(File::Which)
BuildRequires: perl(Games::Solitaire::Verify)
BuildRequires: perl(Games::Solitaire::Verify::Solution)
BuildRequires: perl(Inline)
BuildRequires: perl(Inline::C)
BuildRequires: perl(IPC::Open2)
BuildRequires: perl(lib)
BuildRequires: perl(List::MoreUtils)
BuildRequires: perl(Moo)
BuildRequires: perl(MooX)
BuildRequires: perl(MooX::late)
BuildRequires: perl(parent)
BuildRequires: perl(Path::Tiny)
BuildRequires: perl(Storable)
BuildRequires: perl(strict)
BuildRequires: perl(String::ShellQuote)
BuildRequires: perl(Task::FreecellSolver::Testing)
BuildRequires: perl(Template)
BuildRequires: perl(Test::Data::Split)
BuildRequires: perl(Test::Data::Split::Backend::Hash)
BuildRequires: perl(Test::Data::Split::Backend::ValidateHash)
BuildRequires: perl(Test::Differences)
BuildRequires: perl(Test::More)
BuildRequires: perl(Test::RunValgrind)
BuildRequires: perl(Test::TrailingSpace)
BuildRequires: perl(Test::Trap)
BuildRequires: perl(warnings)
BuildRequires: perl(YAML::XS)
BuildRequires: perl-devel
BuildRequires: pkgconfig(cmocka)
BuildRequires: pkgconfig(librinutils)
BuildRequires: python3-cffi
BuildRequires: python3-freecell_solver
BuildRequires: python3-random2
BuildRequires: python3-pysol-cards
BuildRequires: python3dist(six)
BuildRequires: python3dist(pycotap)
BuildRequires: valgrind

%description
The Freecell Solver package contains the fc-solve executable which is
a command-line program that can be used to solve games of Freecell and
similar card solitaire variants.

This package also contains command line executables to generate the initial
boards of several popular Freecell implementations.

%files
%{_bindir}/dbm-fc-solver
%{_bindir}/depth-dbm-fc-solver
%{_bindir}/fc-solve
%{_bindir}/fc_solve_find_index_s2ints.py
%{_bindir}/find-freecell-deal-index.py
%{_bindir}/freecell-solver-fc-pro-range-solve
%{_bindir}/freecell-solver-multi-thread-solve
%{_bindir}/freecell-solver-range-parallel-solve
%{_bindir}/gen-multiple-pysol-layouts
%{_bindir}/make_pysol_freecell_board.py
%{_bindir}/pi-make-microsoft-freecell-board
%{_bindir}/transpose-freecell-board.py
%{_mandir}/*/*
%{_docdir}/*

#--------------------------------------------------------------------

%package -n %{libname}
Summary: The Freecell Solver dynamic libraries for solving Freecell games
Group: Games/Cards
Requires: %{name}-data >= %{version}-%{release}

%description -n %{libname}
Contains the Freecell Solver libraries that are used by some programs to solve
games of Freecell and similar variants of card solitaire.

This package is mandatory for the Freecell Solver executable too.

%files -n %{libname}
%{_libdir}/libfreecell-solver.so.%{major}{,.*}

#--------------------------------------------------------------------

%package -n %{name}-data
Summary: The Freecell Solver data files
Group: Games/Cards
BuildArch: noarch

%description -n %{name}-data
These are the presets for Freecell Solver

%files -n %{name}-data
%{_datadir}/freecell-solver/

#--------------------------------------------------------------------

%package -n %{develname}
Summary: The Freecell Solver development tools for solving Freecell games
Group: Games/Cards
Requires: %{libname} = %version-%release
Provides: %{name}-devel = %{version}-%{release}

%description -n %{develname}
Freecell Solver is a library for automatically solving boards of Freecell and
similar variants of card Solitaire. This package contains the header files and
static libraries necessary for developing programs using Freecell Solver.

You should install it if you are a game developer who would like to use
Freecell Solver from within your programs.

%files -n %{develname}
%{_includedir}/freecell-solver/
%{_libdir}/pkgconfig/*.pc
%{_libdir}/libfreecell-solver.so

#--------------------------------------------------------------------

%prep
%setup -q

%build
# The game limit flags are recommended by the PySolFC README.
%cmake -DLOCALE_INSTALL_DIR=%{_datadir}/locale \
       -DLIB_INSTALL_DIR=%{_libdir} \
       -DMAX_NUM_FREECELLS=8 \
       -DMAX_NUM_STACKS=20 \
       -DMAX_NUM_INITIAL_CARDS_IN_A_STACK=60 \
       -DFCS_ENABLE_DBM_SOLVER=1
%cmake_build

%check
# no more 'the_silver_searcher' (ag) pkg
rm -f  t/t/spelling.t
%ifnarch %{arm}
rm -f t/t/tidyall.t
cd %{_vpath_builddir}
perl ../run-tests.pl --rebuild
%endif

%install
%cmake_install

# Delete static libraries
find %{buildroot} -name *.a -delete


%changelog
* Fri Dec 29 2023 tv <tv> 6.8.0-3.mga10
+ Revision: 2023465
- Rebuild for python-3.12

* Mon Apr 17 2023 daviddavid <daviddavid> 6.8.0-2.mga9
+ Revision: 1953442
- drop no more available the_silver_searcher build dependency (was only needed for testsuite)

* Thu Jan 05 2023 daviddavid <daviddavid> 6.8.0-1.mga9
+ Revision: 1929979
- new version: 6.8.0

* Wed Apr 06 2022 umeabot <umeabot> 6.6.0-2.mga9
+ Revision: 1845639
- Mageia 9 Mass Rebuild

* Wed Feb 02 2022 mrambo3501 <mrambo3501> 6.6.0-1.mga9
+ Revision: 1771036
- version 6.6.0
- disable rpath check

* Sat Oct 10 2020 shlomif <shlomif> 6.2.0-1.mga8
+ Revision: 1633087
- New version 6.2.0

* Thu Jul 23 2020 shlomif <shlomif> 6.0.1-1.mga8
+ Revision: 1608562
- New version 6.0.1

* Wed Jul 22 2020 shlomif <shlomif> 6.0.0-1.mga8
+ Revision: 1607981
- New version 6.0.0

* Sun May 03 2020 shlomif <shlomif> 5.24.0-1.mga8
+ Revision: 1578603
- New version 5.24.0

* Mon Apr 13 2020 shlomif <shlomif> 5.22.1-1.mga8
+ Revision: 1567103
- New version 5.22.1

* Sat Apr 11 2020 shlomif <shlomif> 5.22.0-1.mga8
+ Revision: 1566311
- New version 5.22.0

* Wed Mar 04 2020 shlomif <shlomif> 5.20.1-1.mga8
+ Revision: 1553618
- New version 5.20.1

* Thu Feb 27 2020 shlomif <shlomif> 5.20.0-1.mga8
+ Revision: 1551021
- New version 5.20.0

* Tue Feb 18 2020 umeabot <umeabot> 5.18.0-2.mga8
+ Revision: 1541571
- Mageia 8 Mass Rebuild

* Wed Feb 12 2020 shlomif <shlomif> 5.18.0-1.mga8
+ Revision: 1501182
- New version 5.18.0

* Mon Dec 30 2019 shlomif <shlomif> 5.16.0-1.mga8
+ Revision: 1474930
- New version 5.16.0
+ wally <wally>
- build with new cmake macros

* Thu Dec 26 2019 shlomif <shlomif> 5.14.0-3.mga8
+ Revision: 1470108
- adapt for new cmake macros

* Fri Oct 18 2019 daviddavid <daviddavid> 5.14.0-2.mga8
+ Revision: 1454432
- disable testsuite on arm

* Fri Aug 30 2019 shlomif <shlomif> 5.14.0-1.mga8
+ Revision: 1435711
- New version 5.14.0

* Tue Aug 13 2019 shlomif <shlomif> 5.12.0-2.mga8
+ Revision: 1429122
- enable installing the dbm-fc-solvers

* Mon Jul 29 2019 shlomif <shlomif> 5.12.0-1.mga8
+ Revision: 1425127
- New version 5.12.0

* Tue Jun 18 2019 shlomif <shlomif> 5.10.0-1.mga8
+ Revision: 1400239
- New version 5.10.0

* Sun Jun 16 2019 shlomif <shlomif> 5.8.0-1.mga7
+ Revision: 1400120
- New version 5.8.0 and some build fixes for it.

* Mon Apr 08 2019 shlomif <shlomif> 5.6.0-1.mga7
+ Revision: 1386783
- New version 5.6.0

* Tue Mar 26 2019 shlomif <shlomif> 5.4.0-2.mga7
+ Revision: 1380368
- made data package noarch

* Sun Mar 17 2019 shlomif <shlomif> 5.4.0-1.mga7
+ Revision: 1378460
- New version 5.4.0

* Wed Feb 20 2019 shlomif <shlomif> 5.2.0-1.mga7
+ Revision: 1368903
- New version 5.2.0

* Sat Oct 27 2018 shlomif <shlomif> 5.0.0-1.mga7
+ Revision: 1326244
- New version 5.0.0

* Sun Sep 23 2018 umeabot <umeabot> 4.20.0-2.mga7
+ Revision: 1297762
- Mageia 7 Mass Rebuild

* Tue Jul 24 2018 shlomif <shlomif> 4.20.0-1.mga7
+ Revision: 1245148
- New version 4.20.0

* Thu Mar 22 2018 shlomif <shlomif> 4.18.0-1.mga7
+ Revision: 1211243
- New version 4.18.0.

* Sun Jan 21 2018 kekepower <kekepower> 4.16.0-3.mga7
+ Revision: 1195568
+ rebuild (emptylog)

* Sun Jan 21 2018 kekepower <kekepower> 4.16.0-2.mga7
+ Revision: 1195525
- Separate data files into its own pacakge

* Sun Jan 21 2018 shlomif <shlomif> 4.16.0-1.mga7
+ Revision: 1195509
- spec cleanups + reenable arm
+ kekepower <kekepower>
- Update to version 4.16.0

* Fri Oct 06 2017 shlomif <shlomif> 4.14.1-1.mga7
+ Revision: 1169637
- New version 4.14.1

* Mon Oct 02 2017 shlomif <shlomif> 4.14.0-1.mga7
+ Revision: 1163494
- fix tests
- Add missing BR on python3-cffi
- Add missing BR on asciidoc
- New version 4.14.0

* Fri Jan 20 2017 shlomif <shlomif> 4.8.0-2.mga6
+ Revision: 1082535
- Add missing BR
- New upstream version 4.8.0 with some fixes.

* Sat Jan 14 2017 shlomif <shlomif> 4.6.1-2.mga6
+ Revision: 1081675
- Serialise the build in hope of fixing the tests failure.
- New upstream version 4.6.1.

* Sun Dec 04 2016 shlomif <shlomif> 4.6.0-2.mga6
+ Revision: 1072461
- Bump the release for a rebuild
- try to fix build on i586
- Add missing build dep
- New version 4.6.0 (drop 2 unnecessary patches).

* Fri Nov 25 2016 shlomif <shlomif> 4.4.0-2.mga6
+ Revision: 1070172
- Hopefully fix code+tests on ARM.

* Thu Sep 22 2016 shlomif <shlomif> 4.4.0-1.mga6
+ Revision: 1055296
- Skip a failing test on i586 - thanks to Akien.
- New version 4.4.0 - add missing deps and modernise .spec.

* Mon Jul 04 2016 pterjan <pterjan> 4.2.0-2.mga6
+ Revision: 1038630
- Exclude from arm until it gets fixed there

* Fri Mar 25 2016 shlomif <shlomif> 4.2.0-1.mga6
+ Revision: 995313
- Add missing BR on Path::Tiny
- New version 4.2.0

* Thu Jan 14 2016 shlomif <shlomif> 4.0.2-1.mga6
+ Revision: 922978
- Update to new ver 4.0.2. (Thanks to Dan Fandrich for the notice).
+ danf <danf>
- Added underlinking.patch to fix underlinking of test lib

* Sun Sep 27 2015 shlomif <shlomif> 4.0.0-1.mga6
+ Revision: 884314
- Add missing BR
- New version 4.0.0

* Wed Oct 15 2014 umeabot <umeabot> 3.26.0-3.mga5
+ Revision: 743678
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild

* Mon May 19 2014 shlomif <shlomif> 3.26.0-1.mga5
+ Revision: 623701
- New version 3.26.0

* Fri Feb 21 2014 shlomif <shlomif> 3.24.0-1.mga5
+ Revision: 595309
- Add missing BRs
- New version 3.24.0

* Mon Oct 21 2013 umeabot <umeabot> 3.22.0-2.mga4
+ Revision: 539323
- Mageia 4 Mass Rebuild

* Sat Oct 05 2013 shlomif <shlomif> 3.22.0-1.mga4
+ Revision: 491970
- New version 3.22.0

* Mon Jul 01 2013 shlomif <shlomif> 3.20.1-1.mga4
+ Revision: 449471
- New version 3.20.1

* Wed Jun 26 2013 shlomif <shlomif> 3.20.0-1.mga4
+ Revision: 447297
- New version 3.20.0

* Thu May 30 2013 shlomif <shlomif> 3.18.1-1.mga4
+ Revision: 433484
- Add Missing BR
- Add Missing BR
- New version 3.18.1 + Enable Test suite

* Fri Jan 11 2013 umeabot <umeabot> 3.16.0-3.mga3
+ Revision: 350812
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 13 2012 shlomif <shlomif> 3.16.0-2.mga3
+ Revision: 330171
- Remove trailing space.
- Change the configuration constants to match PySolFC's recommendations.

* Mon Dec 10 2012 shlomif <shlomif> 3.16.0-1.mga3
+ Revision: 329383
- New version 3.16.0

* Fri Nov 02 2012 shlomif <shlomif> 3.14.1-1.mga3
+ Revision: 312568
- New version 3.14.1

* Thu Nov 01 2012 fwang <fwang> 3.14.0-1.mga3
+ Revision: 311891
- new version 3.14.0

* Sun Jul 08 2012 shlomif <shlomif> 3.12.0-1.mga3
+ Revision: 268912
- New version 3.12.0

* Tue May 29 2012 shlomif <shlomif> 3.10.0-1.mga3
+ Revision: 249484
- New version - 3.10.0

* Thu Nov 10 2011 shlomif <shlomif> 3.8.0-2.mga2
+ Revision: 166243
- New release to test mgarepo's fix for mgarepo submit with the new svn
- Reverted the previous change
- Meaningless change to make sure mgarepo works with the latest subversion.

* Thu Jul 14 2011 shlomif <shlomif> 3.8.0-1.mga2
+ Revision: 124261
- New version - 3.8.0.

* Thu Mar 24 2011 boklm <boklm> 3.4.0-5.mga1
+ Revision: 76138
- rebuild for bug #497

* Wed Mar 23 2011 boklm <boklm> 3.4.0-4.mga1
+ Revision: 75815
- fix devel package name

* Tue Mar 22 2011 dmorgan <dmorgan> 3.4.0-3.mga1
+ Revision: 75485
- Clean spec file
  Use macros
  Fix wrong requires

* Sun Mar 13 2011 philippem <philippem> 3.4.0-2.mga1
+ Revision: 70743
- imported package freecell-solver

